#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ExtractorJobState {
    #[serde(rename = "PENDING")]
    Pending,
    #[serde(rename = "RUNNING")]
    Running,
    #[serde(rename = "FAILED")]
    Failed,
    #[serde(rename = "SUCCEEDED")]
    Succeeded,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ExtractorJobState {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ExtractorJobState::Pending => "PENDING",
            ExtractorJobState::Running => "RUNNING",
            ExtractorJobState::Failed => "FAILED",
            ExtractorJobState::Succeeded => "SUCCEEDED",
            ExtractorJobState::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ExtractorJobState {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ExtractorJobState {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ExtractorJobState {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ExtractorJobState, conjure_object::plain::ParseEnumError> {
        match v {
            "PENDING" => Ok(ExtractorJobState::Pending),
            "RUNNING" => Ok(ExtractorJobState::Running),
            "FAILED" => Ok(ExtractorJobState::Failed),
            "SUCCEEDED" => Ok(ExtractorJobState::Succeeded),
            v => v.parse().map(|v| ExtractorJobState::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ExtractorJobState {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ExtractorJobState, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ExtractorJobState enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
